#!/usr/bin/perl
# author: Fuyuncat
# Site:   WWW.HelloDBA.COM
# Script: http://www.Hellodba.com/Download/check_popular.zip
#
# [0084] The result of this query is that one row is obtained per bucket, with missing buckets coming from 
#        the more popular values. Each row will have the minimum and maximum value for that bucket, along 
#        with the number of rows in that bucket, the sum of the repetition counts and square of the 
#        repetition counts for rows in that bucket, and the number of repetitions for the most popular 
#        value in that bucket. All missing buckets have been folded into the nearest bucket that is larger. 
# [0085] For example, consider if the process ends up with the following: 12  
# minbkt maxbkt  minval  maxval  sumrep  sumrepsq  maxrep  
# 1      1       1       2       2       2         1  
# 1      4       3       4       9       65        8  
# 5      5       5       5       3       9         3  
# 6      6       6       8       4       6         2  
# 7      8       9       10      6       20        4  
# [0086] This would mean that the number 3 is popular because it is the largest value in the missing 
#        buckets 2 and 3 . Notice that the number 9 is not a popular value because it is only the largest 
#        value of a single bucket, bucket 7 , and thus would only appear once as a histogram endpoint. 
#        To calculate density, the influence of the popular value, 3 , would be removed. Since the value 3 
#        appears 8 times, the number 8 is subtracted from the sumrep sum and 64 (square of 8 ) from the 
#        sumrepsq sum. This enables the computation at a density which is based upon the number of rows in 
#        the table, the number of non-popular values in the column, and the sum of the square of the 
#        repetition counts of non-popular values. 
# 

@hbh = ( [1,1,1,2,2,2,1], [1,4,3,4,9,65,8], [5,5,5,5,3,9,3], [6,6,6,8,4,6,2], [7,8,9,10,6,20,4]); 
$cnt = @hbh;

print "Height Balanced Histogram:\n";
print " minbkt maxbkt  minval  maxval  sumrep  sumrepsq  maxrep\n";
print " 1      1       1       2       2       2         1\n";
print " 1      4       3       4       9       65        8\n";
print " 5      5       5       5       3       9         3\n";
print " 6      6       6       8       4       6         2\n";
print " 7      8       9       10      6       20        4\n";

for ($i=0;$i<$cnt;$i++) {
	$minval_eq = ($i==1 || $hbh[$i][1] - $hbh[$i][0] >= 1)?1:0;
	$maxval_eq = ($i==$cnt || $hbh[$i][1] != $hbh[$i+1][0])?1:0;
	$ispopular = 0;
	if ($minval_eq == 1) {
		if ($maxval_eq == 1 && $hbh[$i][2] == $hbh[$i][3]) {
			$ispopular = 1;
			$minval_eq = 0;
		}
		else {
			$ispopular = (($hbh[$i][1] - $hbh[$i][0]) > 1)?1:0;
		}
	}
	if ($ispopular == 1) {
		print "Value $hbh[$i][2] is a popular value\n";
	}
}

